
int[][] starryPalette={{18,63,119},{15,134,182}, {55,202,229}, {245,219,55}, {251,239,203}};

void flowerPath(float x, float y) {
  int[] c;
  float r, fSize, step;
  step = (int)random(2,5);
  for (int i=1; i<360*5; i+=step) {
    r = i/2;
    float[] point = polarPoint(r, i);
    fSize = random(0.5,1);
    c = starryPalette[(int)random(0,starryPalette.length)];
    fill(c[0],c[1],c[2]);
    flower(fSize*step, point[0]+x,point[1]+y, (int)random(13,20));
    step = (int)random(10,40);
  }
}

void flower(float size, float x, float y, int n) {
  float r, shape;
  shape = random(0.1,0.8);
  beginShape();
  for (int i=0; i<360; i++) {
    r = size+size*shape*cos(radians(i*n));
    float[] point = polarPoint(r, i);
    curveVertex(point[0]+x,point[1]+y);
  }
  endShape();
}

float[] polarPoint(float r, float angle) {
  float [] point = new float[2];
  point[0] = r*cos(radians(angle));
  point[1] = r*sin(radians(angle));
  return point;
}

