void nazcaStyles(int n) {
  background(220,200,100);
  for(int i=0;i<n ; i++){
    float angle = random(0,180);
    int size = (int) random(5,23);
    float distance = size * random(30,50);
    t.penUp();
    t.right(angle);
    t.penDown();
    nazcaStyle(size);
    t.penUp();
    t.forward(distance);
  }
}

void nazcaStyle(int scale) {
  for(int i=0;i<4 ; i++){
    ziaSide(scale);
    t.right(90);
  }
  t.penUp();
  t.right(90);
  t.forward(scale*4);
  t.right(90);
  t.forward(scale*4);
  // t.drawTurtle();
  t.penDown();
  centeredCircle(scale*4);
  int choice = (int)random(1,7);
  if(choice == 1)
    triangleSwirl(1);
  else if(choice == 2)
    circularSwirls(2);
  else if(choice == 3)
    circularSwirls(5);
  else if(choice == 4)
    polygonHalt(scale*(int)random(1,5),144);
  else if(choice == 5){
    l = new LSystem(5,45);
    l.iterate(5);
    l.drawLSystem(t);
  }
  else if(choice == 6){
    brownian(scale);
  }
}

void brownian(int scale) {
  for(int i=0;i<100 ; i++){
    int angle = (int)random(0,90);
    int step = (int)random(0,2);
    t.right(angle);
    t.forward(scale*step);
  }
}

void circularSwirls(int angle) {
  for(int i=0;i<1400 ; i++){
    polygon(2,angle);
    angle = angle + 5;
  }
}

void triangleSwirl(int size) {
  for(int i=0;i<10 ; i++){
    polygon(size,118);
    size = size + 5;
  }
}

void ziaSide(int scale) {
  for(int i=0;i<4 ; i++){
    float r = random(0.8,1.4);
    t.forward(r*10*scale);
    t.right(90);
    t.forward(scale);
    t.right(90);
    t.forward(r*10*scale);
    t.left(90);
    t.forward(scale);
    t.left(90);
    // t.drawTurtle();
  }
}

void polygon(int size, int angle) {
  t.forward(size);
  t.right(angle);
}

void polygonHalt(int size, int angle) {
  int rotation = 0;
  t.forward(size);
  t.right(angle);
  rotation = rotation + angle;
  while(rotation%360 > 0) {
    t.forward(size);
    t.right(angle);
    rotation = rotation + angle;
  }
}

class LSystem {
  String axiom;
  String computedWord;
  String[][] rules = {{"F", "F++F++F++"}};
  float size, angle;
  LSystem(float size, float angle) {
    this.size = size;
    this.angle = angle;
    axiom = "F";
    computedWord = axiom;
  }
   
  void iterate (int iterations) {
    String tempWord;
    println("starting word: " +computedWord);
    for(int i=0; i<iterations; i++) {
      tempWord = computedWord;
      computedWord = tempWord.replaceAll(rules[0][0],rules[0][1]);
      println("iteration " + i +": " +computedWord);
    }
  }
  void drawLSystem(Turtle t) {
    char c;
    for (int i=0; i<computedWord.length(); i++) {
      c = computedWord.charAt(i);
      if (c == 'F')
        t.forward(size);
      else if (c == '+')
        t.right(angle);
      else if (c == '-')
        t.left(angle);
    }
  }
}